# API Reference <a name="API Reference" id="api-reference"></a>

## Constructs <a name="Constructs" id="Constructs"></a>

### OpensearchService <a name="OpensearchService" id="fnl-aws-cdk.OpensearchService"></a>

#### Initializers <a name="Initializers" id="fnl-aws-cdk.OpensearchService.Initializer"></a>

```typescript
import { OpensearchService } from 'fnl-aws-cdk'

new OpensearchService(scope: Construct, id: string, props: OpensearchProps)
```

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#fnl-aws-cdk.OpensearchService.Initializer.parameter.scope">scope</a></code> | <code>constructs.Construct</code> | *No description.* |
| <code><a href="#fnl-aws-cdk.OpensearchService.Initializer.parameter.id">id</a></code> | <code>string</code> | *No description.* |
| <code><a href="#fnl-aws-cdk.OpensearchService.Initializer.parameter.props">props</a></code> | <code><a href="#fnl-aws-cdk.OpensearchProps">OpensearchProps</a></code> | *No description.* |

---

##### `scope`<sup>Required</sup> <a name="scope" id="fnl-aws-cdk.OpensearchService.Initializer.parameter.scope"></a>

- *Type:* constructs.Construct

---

##### `id`<sup>Required</sup> <a name="id" id="fnl-aws-cdk.OpensearchService.Initializer.parameter.id"></a>

- *Type:* string

---

##### `props`<sup>Required</sup> <a name="props" id="fnl-aws-cdk.OpensearchService.Initializer.parameter.props"></a>

- *Type:* <a href="#fnl-aws-cdk.OpensearchProps">OpensearchProps</a>

---

#### Methods <a name="Methods" id="Methods"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#fnl-aws-cdk.OpensearchService.toString">toString</a></code> | Returns a string representation of this construct. |

---

##### `toString` <a name="toString" id="fnl-aws-cdk.OpensearchService.toString"></a>

```typescript
public toString(): string
```

Returns a string representation of this construct.

#### Static Functions <a name="Static Functions" id="Static Functions"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#fnl-aws-cdk.OpensearchService.isConstruct">isConstruct</a></code> | Checks if `x` is a construct. |

---

##### ~~`isConstruct`~~ <a name="isConstruct" id="fnl-aws-cdk.OpensearchService.isConstruct"></a>

```typescript
import { OpensearchService } from 'fnl-aws-cdk'

OpensearchService.isConstruct(x: any)
```

Checks if `x` is a construct.

###### `x`<sup>Required</sup> <a name="x" id="fnl-aws-cdk.OpensearchService.isConstruct.parameter.x"></a>

- *Type:* any

Any object.

---

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#fnl-aws-cdk.OpensearchService.property.node">node</a></code> | <code>constructs.Node</code> | The tree node. |

---

##### `node`<sup>Required</sup> <a name="node" id="fnl-aws-cdk.OpensearchService.property.node"></a>

```typescript
public readonly node: Node;
```

- *Type:* constructs.Node

The tree node.

---


## Structs <a name="Structs" id="Structs"></a>

### OpensearchProps <a name="OpensearchProps" id="fnl-aws-cdk.OpensearchProps"></a>

#### Initializer <a name="Initializer" id="fnl-aws-cdk.OpensearchProps.Initializer"></a>

```typescript
import { OpensearchProps } from 'fnl-aws-cdk'

const opensearchProps: OpensearchProps = { ... }
```

#### Properties <a name="Properties" id="Properties"></a>

| **Name** | **Type** | **Description** |
| --- | --- | --- |
| <code><a href="#fnl-aws-cdk.OpensearchProps.property.program">program</a></code> | <code>string</code> | *No description.* |
| <code><a href="#fnl-aws-cdk.OpensearchProps.property.project">project</a></code> | <code>string</code> | *No description.* |
| <code><a href="#fnl-aws-cdk.OpensearchProps.property.tier">tier</a></code> | <code><a href="#fnl-aws-cdk.Tier">Tier</a></code> | *No description.* |
| <code><a href="#fnl-aws-cdk.OpensearchProps.property.username">username</a></code> | <code>string</code> | *No description.* |
| <code><a href="#fnl-aws-cdk.OpensearchProps.property.domainProps">domainProps</a></code> | <code>aws-cdk-lib.aws_opensearchservice.DomainProps</code> | *No description.* |

---

##### `program`<sup>Required</sup> <a name="program" id="fnl-aws-cdk.OpensearchProps.property.program"></a>

```typescript
public readonly program: string;
```

- *Type:* string

---

##### `project`<sup>Required</sup> <a name="project" id="fnl-aws-cdk.OpensearchProps.property.project"></a>

```typescript
public readonly project: string;
```

- *Type:* string

---

##### `tier`<sup>Required</sup> <a name="tier" id="fnl-aws-cdk.OpensearchProps.property.tier"></a>

```typescript
public readonly tier: Tier;
```

- *Type:* <a href="#fnl-aws-cdk.Tier">Tier</a>

---

##### `username`<sup>Required</sup> <a name="username" id="fnl-aws-cdk.OpensearchProps.property.username"></a>

```typescript
public readonly username: string;
```

- *Type:* string

---

##### `domainProps`<sup>Optional</sup> <a name="domainProps" id="fnl-aws-cdk.OpensearchProps.property.domainProps"></a>

```typescript
public readonly domainProps: DomainProps;
```

- *Type:* aws-cdk-lib.aws_opensearchservice.DomainProps

---



## Enums <a name="Enums" id="Enums"></a>

### Tier <a name="Tier" id="fnl-aws-cdk.Tier"></a>

#### Members <a name="Members" id="Members"></a>

| **Name** | **Description** |
| --- | --- |
| <code><a href="#fnl-aws-cdk.Tier.DEV">DEV</a></code> | *No description.* |
| <code><a href="#fnl-aws-cdk.Tier.QA">QA</a></code> | *No description.* |
| <code><a href="#fnl-aws-cdk.Tier.STAGE">STAGE</a></code> | *No description.* |
| <code><a href="#fnl-aws-cdk.Tier.PROD">PROD</a></code> | *No description.* |

---

##### `DEV` <a name="DEV" id="fnl-aws-cdk.Tier.DEV"></a>

---


##### `QA` <a name="QA" id="fnl-aws-cdk.Tier.QA"></a>

---


##### `STAGE` <a name="STAGE" id="fnl-aws-cdk.Tier.STAGE"></a>

---


##### `PROD` <a name="PROD" id="fnl-aws-cdk.Tier.PROD"></a>

---

